/*
Copyright (c) 2011 by EM Code Services
*/
(function () {

    var animateX = -20;
    var animateInterval = 50;

    var currentPage = null;
    var currentDialog = null;
    var currentWidth = 0;
    var currentHash = location.hash;
    var hashPrefix = "#_";
    var pageHistory = [];
    var fromPage = null;
    var toPage = null;
    var backwards = null;
    var fromLink = null;
    if (window.addEventListener) { // Mozilla, Netscape, Firefox
        addEventListener("load", function (event) {
            var body = document.getElementsByTagName("body")[0];
            for (var child = body.firstChild; child; child = child.nextSibling) {
                if (child.nodeType == 1 && child.getAttribute("selected") == "true") {
                    showPage(child);
                    break;
                }
            }

            //setInterval(checkOrientAndLocation, 300);
            setTimeout(scrollTo, 0, 0, 1);
        }, false);
    } else { // IE
        attachEvent("onload", function (event) {
            var body = document.getElementsByTagName("body")[0];
            for (var child = body.firstChild; child; child = child.nextSibling) {
                if (child.nodeType == 1 && child.getAttribute("selected") == "true") {
                    showPage(child);
                    break;
                }
            }
            //setInterval(checkOrientAndLocation, 300);
            setTimeout(scrollTo, 0, 0, 1);
        });
    }

    if (window.addEventListener) { // Mozilla, Netscape, Firefox
        addEventListener("click", function (event) {
            var link = event.target;
            fromLink = link;
            while (link && link.localName && link.localName.toLowerCase() != "a")
                link = link.parentNode;

            if (event.srcElement.id == "homeButton") {
                backwards = true;
                event.preventDefault();
                pageHistory.pop();
                var prevPage = pageHistory.pop();
                toPage = document.getElementById(prevPage);
                showPage(toPage);
            }
            else if (event.srcElement.id == "doneButton") {
                // do nothing
                event.preventDefault();
            }
            else if (link && link.hash) {
                event.preventDefault();
                toPage = document.getElementById(link.hash.substr(1));
                showPage(toPage);
            }
            else {
			} 
        }, true);
    } else { // IE
        document.attachEvent("onclick", function (event) {
            if (document.preventDefault)
                event.preventDefault();
            else
            // IE
                event.returnValue = false;

            var link = event.srcElement;
            fromLink = link;
            while (link && link.nodeName.toLowerCase() != "a")
                link = link.parentNode;

            if (link && link.hash) {
                if (link.outerText.toLowerCase() != "home")
                    link.className = 'showLoading';

                toPage = document.getElementById(link.hash.substr(1));

                setTimeout(elapseShowPage, 300);
                setTimeout(elapseClick, 350);
            }
        });
    }

    function elapseShowPage() {
        showPage(toPage);
    }

    function elapseClick() {
        if (fromLink) {
            if (fromLink.outerText.toLowerCase() != "home")
                fromLink.className = 'showArrow';
        }
    }

    function checkOrientAndLocation() {
        if (window.outerWidth != currentWidth) {
            currentWidth = window.outerWidth;

            var orient = currentWidth == 320 ? "profile" : "landscape";
            document.body.setAttribute("orient", orient);
        }

        if (location.hash != currentHash) {
            currentHash = location.hash;

            var pageId = currentHash.substr(hashPrefix.length);
            toPage = document.getElementById(pageId);
            if (toPage) {
                var index = pageHistory.indexOf(pageId);
                var backwards = index != -1;
                if (backwards)
                    pageHistory.splice(index, pageHistory.length);

                showPage(toPage, backwards);
            }
        }
    }

    function showPage(page, backwards) {
        if (currentDialog) {
            currentDialog.removeAttribute("selected");
            currentDialog = null;
        }

        if (page.className.indexOf("dialog") != -1) {
            showDialog(page);
        }
        else {
            location.href = currentHash = hashPrefix + page.id;
            pageHistory.push(page.id);

            fromPage = currentPage;
            currentPage = page;

            var pageTitle = document.getElementById("pageTitle");
            pageTitle.innerHTML = page.title || "";

            var homeButton = document.getElementById("homeButton");
            if (homeButton) {
                homeButton.style.display = ("#" + page.id) == homeButton.hash ? "none" : "inline";
                homeButton.innerText = "Back";
                if (homeButton.style.display == "inline")
                    document.getElementById("aboutButton").style.display = "none";
                else
                    document.getElementById("aboutButton").style.display = "inline";
            }

            if (fromPage) {
                scrollTo(0, 1);
                /*$('body').append('<div id="progress" style="display:block;height=20px;">Loading...</div>');*/
                /*setTimeout(swipePage, 100);*/
				swipePage();
            }
        }
    }

    function swipePage() {
        /*toPage.style.left = "100%";*/
        fromPage.style.display = "none";
        toPage.style.display = "inline";
        toPage.setAttribute("selected", "true");
        /*$('#progress').remove();*/
        /*scrollTo(0, 1);*/

        /*var percent = 100;
          var timer = setInterval(function () {
			percent += animateX;
		 if (percent <= 0) {
			percent = 0;
			fromPage.removeAttribute("selected");
			clearInterval(timer);
			$('#progress').remove();
			backwards = false;
        }
        fromPage.style.left = (backwards ? (100 - percent) : (percent - 100)) + "%";
        toPage.style.left = (backwards ? -percent : percent) + "%";
        }, animateInterval);*/
    }

    function showDialog(form) {
        currentDialog = form;
        form.setAttribute("selected", "true");

        form.onsubmit = function (event) {
            event.preventDefault();
            form.removeAttribute("selected");

            var index = form.action.lastIndexOf("#");
            if (index != -1) {
                showPage(document.getElementById(form.action.substr(index + 1)));
                /*showPage(currentPage);*/
            }
        }

        form.onclick = function (event) {
            if (event.target == form) {
                form.removeAttribute("selected");
            }
            else if (event.target.id == "doneButton") {
                backwards = true;
                pageHistory.pop();
                form.removeAttribute("selected");
                toPage = currentPage;
                showPage(currentPage);
            }
        }
    }

})();

