/* 
Copyright (c) 2011 by EM Code Services
*/
	var globalState = "00836",  /* default WA */
	globalCounty = "02",    /* default Seattle King county */
	globalPE2011gpci2,
	globalMP2011gpci,
	globalWork2011gpci1,
	globalFacilityFee,
	globalNonFacilityFee,
	globalWorkRVU, /* workrvu */
	globalMPRVU,   /* mprvu */
	globalConvfactor, /* convfactor */
	globalTransitionedFacilityPERVU, /* transitionedfacilitypervu */
	globalTransitionedNonFacPERVU, /* transitionednon-facpervu */
	globalTotalVisits = 0,
	globalTotalRVU = 0,
	globalArrayRVU = [];

	function parseAllServices() {
		      
		loadStats();
		loadLocation();
		if (globalState == null || globalCounty == null) {
			globalState = "00836";
			globalCounty = "02";
		}
		populateState();
		parseGCPI(globalState, globalCounty);				
		parseServices(1, "Hospital Care");
		parseServices(4, "Outpatient/Office");

		animatedcollapse.addDiv('serviceDiv1', 'optional_attribute_string');
		animatedcollapse.addDiv('serviceDiv4', 'optional_attribute_string');
		animatedcollapse.init();
	}
	var gParseServices = null;
	function parseServices(serviceId, serviceName) {
		var div = document.getElementById('service' + serviceId + 'Container'),
		xml = document.getElementById('services');
		div.innerHTML = "";        
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = xml.innerHTML;
		if (gParseServices == null) {
		    gParseServices = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
			var serviceDiv = document.createElement("div"),
			serviceUl = document.createElement("ul");
			serviceDiv.style.marginTop = "-20px";
			serviceDiv.style.display = "none";
			serviceDiv.id = "serviceDiv" + serviceId;
			serviceDiv.appendChild(serviceUl);

			var ul = document.createElement("ul"),
			liHeading = document.createElement("li"),
			aHeading = document.createElement("a");
			aHeading.id = serviceId + "serviceDiv" + serviceId;
			aHeading.setAttribute("serviceId", serviceId);
			aHeading.setAttribute("class", "subheadingExpand");
			aHeading.onclick = _onExpandServiceDiv;
			aHeading.innerText = serviceName;
			liHeading.appendChild(aHeading);
			ul.appendChild(liHeading);
			div.appendChild(ul);
			gParseServices.find("service").each(function () {
				if ($(this).attr("service") == serviceId) {
					var li = document.createElement("li"),
					anchorCode = document.createElement("a");
					anchorCode.setAttribute("class", "showArrow");
					anchorCode.setAttribute("href", "#codesHome");
					anchorCode.innerText = $(this).attr("lineone");
					anchorCode.setAttribute("title", $(this).attr("lineone"));
					anchorCode.setAttribute("service", $(this).attr("service"));
					anchorCode.setAttribute("id", $(this).attr("id"));
					anchorCode.onclick = _onServiceClick;
					li.appendChild(anchorCode);
					serviceUl.appendChild(li);                    
				}
			});
			div.appendChild(serviceDiv);
		} catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	var gParseCodes = null;
	function parseCodes(title, serviceId, codeId) {
		var div = document.getElementById('codesDiv'),
		msg = document.getElementById('codesMessageDiv'),        
		xml = document.getElementById('codes');
		div.innerHTML = "";
		msg.innerHTML = "";
		//title = title.substring(0, 22) + "...";
		//div.setAttribute("title", title);
		//document.getElementById("pageTitle").innerText = title;
		div.setAttribute("selected", "true");

		// add msg notice
		var anchorTitle = populateMsg(msg, title);
	  
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseCodes == null) {
		    gParseCodes = $($.parseXML(xmlContent3));
		}
		try {
		    /*if (typeof gParseCodes === 'object') {
		        for (var prop in gParseCodes) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseCodes.find("service").each(function () {
		    	if ($(this).attr("id") == codeId) {
		    		var reqComponents = $(this).attr("requires");
		    		anchorTitle.innerText += " (requires " + reqComponents + " components)";
					$(this).find("code").each(function () {
						var ul = document.createElement("ul"),
						liHeading = document.createElement("li"),
						aHeading = document.createElement("a");
						aHeading.setAttribute("class", "subheadingExpand");
						aHeading.setAttribute("hemId", $(this).attr("id"));
						aHeading.onclick = _onExpandCode;
						//var substringLevel = $(this).attr("id").substring(4);
						//var substringCode = $(this).attr("id").substring(2);
						//aHeading.innerText = "Level " + substringLevel + ", " + substringCode;
						aHeading.innerText = "Level " + $(this).attr("id");
						liHeading.appendChild(aHeading);
						ul.appendChild(liHeading);

						var hemDiv = document.createElement("div"),
						hemUl = document.createElement("ul"),
						liHx = document.createElement("li"),
						anchorHx = document.createElement("a");
						hemDiv.style.marginTop = "-5px";
						hemDiv.style.display = "none";
						hemDiv.id = "hemDiv" + $(this).attr("id");
						anchorHx.setAttribute("hx", $(this).attr("hx"));
						anchorHx.innerText = "History: " + $(this).attr("hx");
						if ($(this).attr("hx") != "NA" && $(this).attr("hx") != "Not Required") {
							anchorHx.setAttribute("class", "showArrow");
							anchorHx.setAttribute("href", "#histDiv");
							anchorHx.onclick = _onHistoryClick;
						}
						liHx.appendChild(anchorHx);
						hemUl.appendChild(liHx);
						hemDiv.appendChild(hemUl);
						var liExam = document.createElement("li"),
					    anchorExam = document.createElement("a");
						anchorExam.setAttribute("exam", $(this).attr("exam"));
						anchorExam["innerText"] = "Exam: " + $(this).attr("exam");
						if ($(this).attr("exam") != "NA") {
							anchorExam.setAttribute("class", "showArrow");
							anchorExam.onclick = _onExamClick;
							anchorExam.setAttribute("href", "#examDiv");
						}
						liExam.appendChild(anchorExam);
						hemUl.appendChild(liExam);
						hemDiv.appendChild(hemUl);
						var liMDM = document.createElement("li"),
						anchorMDM = document.createElement("a");
						anchorMDM.setAttribute("mdm", $(this).attr("mdm"));
						var mdmText = $(this).attr("mdm");

						if ($(this).attr("mdm") != "NA") {
							anchorMDM.setAttribute("class", "showArrow");
							var divName = mdmText.replace(/ /g,"_");
							anchorMDM.setAttribute("href", "#mdmDiv"+divName);
							mdmText += " Complexity";
						}
						anchorMDM["innerText"] = "MDM: " + mdmText;

						liMDM.appendChild(anchorMDM);
						hemUl.appendChild(liMDM);
						hemDiv.appendChild(hemUl);
						ul.appendChild(hemDiv);
						div.appendChild(ul);

						animatedcollapse.addDiv(hemDiv.id, 'optional_attribute_string');

						/*
						var liSev = document.createElement("li");
						var anchorSev = document.createElement("a");
						anchorSev["innerText"] = "SEV: " + $(this).attr("sev");
						liSev.appendChild(anchorSev);
						ul.appendChild(liSev);
						div.appendChild(ul);
						*/

						var liTime = document.createElement("li"),
						anchorTime = document.createElement("a");
						anchorTime["innerText"] = "Time: " + $(this).attr("time") + " mins";
						if ($(this).attr("time") == "NA") {
							anchorTime["innerText"] = "Time: " + $(this).attr("time");
						}
						liTime.appendChild(anchorTime);
						ul.appendChild(liTime);
						div.appendChild(ul);

						var liRVU = document.createElement("li"),
						anchorRVU = document.createElement("a");
						anchorRVU.setAttribute("class", "showArrow");
						anchorRVU.setAttribute("code", $(this).attr("id"));
						anchorRVU.onclick = _onCodeRvuClick;
						anchorRVU.setAttribute("href", "#rvuDiv");
						var workRvu = calcWorkRvu($(this).attr("id"));
						anchorRVU["innerText"] = "RVU: " + workRvu;
						liRVU.appendChild(anchorRVU);
						ul.appendChild(liRVU);
						div.appendChild(ul);

					});
				}
			});
				
		} catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}        
	}
	var gParseExams = null;
	function parseExam(examDesc) {
		var div = document.getElementById('examHeader'),           
		xml = document.getElementById('exam97'),
		examTypes = examDesc.split("or");
		div.innerHTML = "";
		div.setAttribute("selected", "true");
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseExams == null) {
		    gParseExams = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
			var ul = document.createElement("ul");
			gParseExams.find("exam97").each(function () {
				if ($(this).attr("name") == "General Multi-System") {
					$(this).find("level").each(function () {
						if ($(this).attr("type") == jQuery.trim(examTypes[0])) {
							var li = document.createElement("li"),
							anchorExam = document.createElement("a");
							anchorExam.innerText = $(this).attr("definition");
							li.appendChild(anchorExam);
							ul.appendChild(li);
						}
						if ($(this).attr("type") == jQuery.trim(examTypes[1])) {
							var li = document.createElement("li"),
							anchorExam = document.createElement("a");
							anchorExam.innerText = $(this).attr("definition");
							li.appendChild(anchorExam);
							ul.appendChild(li);                           
						}                       
					});
				}
			});
			div.appendChild(ul);
		} catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	var gParseStates = null;
	function populateState() {
		var div = document.getElementById('state'),
		xml = document.getElementById('locality');
		div.innerHTML = "";
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseStates == null) {
		    gParseStates = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseStates.find("local").each(function () {
				var opt = document.createElement("option"),
				statecounty = $(this).attr("name") + ", " + $(this).attr("county");
				opt.setAttribute("value", statecounty);
				opt.setAttribute("stateid", $(this).attr("stateid"));
				opt.setAttribute("countyid", $(this).attr("countyid"));
				if (($(this).attr("stateid") == globalState) &&
					($(this).attr("countyid") == globalCounty)) {
					opt.selected = true;
				}
				opt.innerText = statecounty;
				div.appendChild(opt);

			});
		} catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}         
	}
	var gParseGCPI = null;
	function parseGCPI(stateId, countyId) {
		var xml = document.getElementById('gcpi');
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseGCPI == null) {
		    gParseGCPI = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseGCPI.find("gcpi").each(function () {                   
				var local1 = parseInt($(this).find("contractor").text(), 10),
				local2 = parseInt(stateId, 10),
				local3 = parseInt($(this).find("locality").text(), 10),
				local4 = parseInt(countyId, 10);
				if ((local2 == local1) && (local3 == local4)) {
					globalPE2011gpci2 = parseFloat($(this).find("pe2011gpci2").text());
					globalMP2011gpci = parseFloat($(this).find("mp2011gpci").text());
					globalWork2011gpci1 = parseFloat($(this).find("work2011gpci1").text());  

                    return false;                  
				}
			});
		} 
		catch (e) {
				div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	var gParseCodeRvu = null;
	function parseCodeRvu(codeId) {
		var div = document.getElementById('rvuDiv'),
	    xml = document.getElementById('rvu');
		div.innerHTML = "";
		div.setAttribute("selected", "true");
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseCodeRvu == null) {
		    gParseCodeRvu = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseCodeRvu.find("code").each(function () {                   
				var local1 = parseInt($(this).find("hcpcs").text(), 10),
				local2 = parseInt(codeId, 10);
				if (local2 == local1) {
					globalWorkRVU = parseFloat($(this).find("workrvu").text());
					globalMPRVU = parseFloat($(this).find("mprvu").text());
					globalConvfactor = parseFloat($(this).find("convfactor").text());
					globalTransitionedFacilityPERVU = parseFloat($(this).find("transitionedfacilitypervu").text());
					globalTransitionedNonFacPERVU = parseFloat($(this).find("transitionednon-facpervu").text());

					globalFacilityFee = _calcFacilityFee();
					globalNonFacilityFee = _calcNonFacilityFee();

					var ul = document.createElement("ul"),
					liHeading = document.createElement("li"),
					aHeading = document.createElement("a");
					aHeading.setAttribute("class", "subheading");
					aHeading.innerText = codeId;
					liHeading.appendChild(aHeading);
					ul.appendChild(liHeading);

					var liMDM = document.createElement("li"),
					anchorMDM = document.createElement("a");
					anchorMDM["innerText"] = "RVU: " + globalWorkRVU;
					liMDM.appendChild(anchorMDM);
					ul.appendChild(liMDM);
					div.appendChild(ul);

					var liFacFee = document.createElement("li"),
					anchorFacFee = document.createElement("a");
					anchorFacFee["innerText"] = "Facility fee: " + globalFacilityFee.toFixed(2);
					liFacFee.appendChild(anchorFacFee);
					ul.appendChild(liFacFee);
					div.appendChild(ul);
				  
					var liNonFacFee = document.createElement("li"),
					anchorNonFacFee = document.createElement("a");
					anchorNonFacFee["innerText"] = "Non-Facility fee: " + globalNonFacilityFee.toFixed(2);
					liNonFacFee.appendChild(anchorNonFacFee);
					ul.appendChild(liNonFacFee);
					div.appendChild(ul);  
                    
                    return false;           
				}
			});
		} 
		catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	var gParseHistory = null;
	function parseHistory(histDesc) {
		var div = document.getElementById('histDiv'),
		xml = document.getElementById('hist'),
		histTypes = histDesc.split("or");
		div.innerHTML = "";
		div.setAttribute("selected", "true");
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseHistory == null) {
		    gParseHistory = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseHistory.find("historyrequirements").each(function () {
				$(this).find("item").each(function () {
					if ($(this).attr("type") == jQuery.trim(histTypes[0])) {
						var cc = $(this).attr("cc"),
						hpi = $(this).attr("hpi"),
						ros = $(this).attr("ros"),
						pfsh = $(this).attr("pfsh");
						gParseHistory.find("ccrequirments").each(function () {
							$(this).find("item").each(function () {
								if ($(this).attr("type") == cc) {
									var ul = document.createElement("ul"),
									liHeading = document.createElement("li"),
									aHeading = document.createElement("a");
									aHeading.setAttribute("class", "subheadingShowArrow");
									aHeading.innerText = "CC";
									aHeading.setAttribute("href", "#ccDiv");
									liHeading.appendChild(aHeading);
									ul.appendChild(liHeading);

									var li = document.createElement("li"),
									anchorCode = document.createElement("a");									
									anchorCode.innerText = $(this).attr("definition");

									li.appendChild(anchorCode);
									ul.appendChild(li);
									div.appendChild(ul);

                                    return false;    
								}
							});
						});

                        gParseHistory.find("hpirequirements").each(function () {
							$(this).find("item").each(function () {
								if ($(this).attr("type") == hpi) {
									var ul = document.createElement("ul"),
									liHeading = document.createElement("li"),
									aHeading = document.createElement("a");
									aHeading.setAttribute("class", "subheadingShowArrow");
									aHeading.innerText = "HPI";
									aHeading.setAttribute("href", "#hpiDiv");
									liHeading.appendChild(aHeading);
									ul.appendChild(liHeading);

									var li = document.createElement("li"),
									anchorCode = document.createElement("a");
									anchorCode.innerText = $(this).attr("definition");									

									li.appendChild(anchorCode);
									ul.appendChild(li);
									div.appendChild(ul);

                                    return false;    
								}
							});
						});
                        gParseHistory.find("rosrequirements").each(function () {
							$(this).find("item").each(function () {
								if ($(this).attr("type") == ros) {
									var ul = document.createElement("ul"),
									liHeading = document.createElement("li"),
									aHeading = document.createElement("a");
									aHeading.setAttribute("class", "subheadingShowArrow");
									aHeading.innerText = "ROS";
									aHeading.setAttribute("href", "#rosDiv");
									liHeading.appendChild(aHeading);
									ul.appendChild(liHeading);

									var li = document.createElement("li"),
									anchorCode = document.createElement("a");
									anchorCode.innerText = $(this).attr("definition");
									
									li.appendChild(anchorCode);
									ul.appendChild(li);
									div.appendChild(ul);

                                    return false;    
								}
							});
						});
                        gParseHistory.find("pfshrequirements").each(function () {
							$(this).find("item").each(function () {
								if ($(this).attr("type") == pfsh) {
									var ul = document.createElement("ul"),
									liHeading = document.createElement("li"),
									aHeading = document.createElement("a");
									aHeading.setAttribute("class", "subheadingShowArrow");
									aHeading.innerText = "PFSH";
									aHeading.setAttribute("href", "#pfshDiv");
									liHeading.appendChild(aHeading);
									ul.appendChild(liHeading);

									var li = document.createElement("li"),
									anchorCode = document.createElement("a");                                   
									anchorCode.innerText = $(this).attr("definition");
									
									li.appendChild(anchorCode);
									ul.appendChild(li);
									div.appendChild(ul);

                                    return false;    
								}
							});
						});
					}
				});
			});
		} 
		catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	var gParseRvu = null;
	function calcWorkRvu(codeId) {
		var workRvu = 0,
		xml = document.getElementById('rvu');
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseRvu == null) {
		    gParseRvu = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseRvu.find("code").each(function () {
				var local1 = parseInt($(this).find("hcpcs").text(), 10),
				local2 = parseInt(codeId, 10);
				if (local2 == local1) {
					workRvu = parseFloat($(this).find("workrvu").text());
					return false;    
				}
			});
		} 
		catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
		return workRvu;
	}
	var gParseRvuFacFee = null;
	function calcRvuFacilityFee(codeId) {
		var rvuFacilityFee = 0,
		xml = document.getElementById('rvu');
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseRvuFacFee == null) {
		    gParseRvuFacFee = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseRvuFacFee.find("code").each(function () {
				var local1 = parseInt($(this).find("hcpcs").text(), 10),
				local2 = parseInt(codeId, 10);
				if (local2 == local1) {
					globalWorkRVU = parseFloat($(this).find("workrvu").text());
					globalMPRVU = parseFloat($(this).find("mprvu").text());
					globalConvfactor = parseFloat($(this).find("convfactor").text());
					globalTransitionedFacilityPERVU = parseFloat($(this).find("transitionedfacilitypervu").text());
					globalTransitionedNonFacPERVU = parseFloat($(this).find("transitionednon-facpervu").text());

					rvuFacilityFee = _calcFacilityFee();    
                    return false;                                      
				}
			});
		} 
		catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	var gParseRvuNonFacFee = null;
	function calcRvuNonFacilityFee(codeId) {
		var rvuNonFacilityFee = 0;
		var xml = document.getElementById('rvu');
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseRvuNonFacFee == null) {
		    gParseRvuNonFacFee = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParseRvuNonFacFee.find("code").each(function () {
				var local1 = parseInt($(this).find("hcpcs").text(), 10);
				var local2 = parseInt(codeId, 10);
				if (local2 == local1) {
					globalWorkRVU = parseFloat($(this).find("workrvu").text());
					globalMPRVU = parseFloat($(this).find("mprvu").text());
					globalConvfactor = parseFloat($(this).find("convfactor").text());
					globalTransitionedFacilityPERVU = parseFloat($(this).find("transitionedfacilitypervu").text());
					globalTransitionedNonFacPERVU = parseFloat($(this).find("transitionednon-facpervu").text());

					rvuNonFacilityFee = _calcNonFacilityFee(); 
                    return false;                  
				}
			});
		} 
		catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	function populateAllVisits() {		
		populateVisits(1, "Hospital Care");		
		populateVisits(2, "Observation");				
		populateVisits(4, "Outpatient/Office");		
		populateVisits(6, "Emergency Dept");		
		populateVisits(7, "Nursing Facility");		
		populateVisits(8, "Assisted Living");		
		populateVisits(9, "Home Care");
		
		animatedcollapse.addDiv('visitsDiv1', 'optional_attribute_string');
		animatedcollapse.addDiv('visitsDiv2', 'optional_attribute_string');
		animatedcollapse.addDiv('visitsDiv3', 'optional_attribute_string');
		animatedcollapse.addDiv('visitsDiv4', 'optional_attribute_string');
		animatedcollapse.addDiv('visitsDiv6', 'optional_attribute_string');
		animatedcollapse.addDiv('visitsDiv7', 'optional_attribute_string');
		animatedcollapse.addDiv('visitsDiv8', 'optional_attribute_string');
		animatedcollapse.addDiv('visitsDiv9', 'optional_attribute_string');
		animatedcollapse.init();
	}
	var gParseVisits = null;
	function populateVisits(serviceId, serviceName) {
		var div = document.getElementById('visits' + serviceId + 'Container');
		div.innerHTML = "";
		var xml = document.getElementById('services');
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = xml.innerHTML;
		if (gParseVisits == null) {
		    gParseVisits = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
			var visitsDiv = document.createElement("div");
			visitsDiv.style.marginTop = "-30px";
			visitsDiv.style.display = "none";
			visitsDiv.id = "visitsDiv" + serviceId;
			var visitsUl = document.createElement("ul");
			visitsDiv.appendChild(visitsUl);

			var ul = document.createElement("ul"),
			liHeading = document.createElement("li"),
			aHeading = document.createElement("a");
			aHeading.id = serviceId + "visitsDiv" + serviceId;
			aHeading.setAttribute("class", "subheadingExpand");
			aHeading.setAttribute("serviceId", serviceId);
			aHeading.onclick = _onVisitServiceClick;
			aHeading.innerText = serviceName;
			liHeading.appendChild(aHeading);
			ul.appendChild(liHeading);
			div.appendChild(ul);
			gParseVisits.find("service").each(function () {
				if ($(this).attr("service") == serviceId) {
					populateVisitsCodes(aHeading, visitsUl, serviceId, $(this).attr("id"));	                    					
				}
			});			
			/*div.appendChild(ul);*/
			div.appendChild(visitsDiv);
            
		} catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	var gParsePopVisitCodes = null;
	function populateVisitsCodes(header, ul, serviceId, codeId) {        
		var xml = document.getElementById('codes');          
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParsePopVisitCodes == null) {
		    gParsePopVisitCodes = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
		    gParsePopVisitCodes.find("service").each(function () {
				if ($(this).attr("id") == codeId) {
					$(this).find("code").each(function () {						
						var aLi = document.createElement("li");
						var aLabel = document.createElement("label");
						aLabel.innerText = $(this).attr("id") + ":";
						var aInput = document.createElement("input");
						aInput.setAttribute("service", serviceId);
						aInput.setAttribute("type", "tel");
						aInput.setAttribute("id", "_" + $(this).attr("id") + "_" + serviceId);
						aInput.setAttribute("value", "0");
						var c = "_" + $(this).attr("id") + "_" + serviceId;
						if (globalArrayRVU[c] > 0) {
							aInput.setAttribute("value", globalArrayRVU[c]);
							header.style.color = "red";
						}
						aInput.onchange = _onVisitInputChange;
						aLi.appendChild(aLabel);
						aLi.appendChild(aInput);
						ul.appendChild(aLi);                       
					});
				}
			});

		} catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	function populateMdmRiskTable(riskId, riskName) {
		var div = document.getElementById('risk' + riskId + 'Container');
		div.innerHTML = "";
		var riskDiv = document.createElement("div");
		riskDiv.style.marginTop = "-20px";
		riskDiv.style.display = "none";
		riskDiv.id = "riskDiv" + riskId;
		var riskUl = document.createElement("ul");
		riskDiv.appendChild(riskUl);

		var ul = document.createElement("ul"),
		liHeading = document.createElement("li"),
		aHeading = document.createElement("a");
		aHeading.id = riskId + "riskDiv" + riskId;
		aHeading.setAttribute("class", "subheadingExpand");
		aHeading.setAttribute("riskId", riskId);
		aHeading.onclick = _onMdmRiskClick;
		aHeading.innerText = riskName;
		liHeading.appendChild(aHeading);
		ul.appendChild(liHeading);
		div.appendChild(ul);
		populateRiskName(aHeading, riskUl, riskId, riskName);
		div.appendChild(riskDiv);
	}
	var gParseRisktable = null;
	function populateRiskName(div, ul, id, name) {
		var xml = document.getElementById('risktable');
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		if (gParseRisktable == null) {
		    gParseRisktable = $($.parseXML(xmlContent3));
		}
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
			var uniqueId = id;
			gParseRisktable.find(name).each(function () {
			    var aLi = document.createElement("li"),
				anchor = document.createElement("a"),
				aInput = document.createElement("input"),
				inputId = "page4_checkbox_risk" + $(this).attr("level"),
				inputUniqueId = uniqueId + Math.floor(Math.random() * 32767);
			    anchor.setAttribute("onclick", "document.getElementById('" + inputUniqueId + "').click();updateRiskCheckBox(this,"+inputUniqueId+");readPage4();");
			    //aInput.setAttribute("class", "input inputCheckbox");
			    aInput.style.display = "none";
			    aInput.type = "checkbox";
			    aInput.id = inputUniqueId;
			    aInput.name = inputId;
			    aInput.setAttribute("level", $(this).attr("level"));
			    anchor.innerText = $(this).text();
			    anchor.appendChild(aInput);
			    aLi.appendChild(anchor);
			    ul.appendChild(aLi);
			    uniqueId++;
			});

		} catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
	}
	function updateRiskCheckBox(obj, id) {
        if (document.getElementById(id).checked)            
            obj.style.backgroundColor = "#c0e0ff";
	    else
	        obj.style.backgroundColor = "";
	}
	function populateMsg(msg, title) {
		var div = document.getElementById('titleDefDiv');
		var xml = document.getElementById('mtitles');
		div.innerHTML = "";
		var ul = document.createElement("ul");
		var liHeading = document.createElement("li");
		var aHeading = document.createElement("a");		
		aHeading.innerText = title;
		liHeading.appendChild(aHeading);
		ul.appendChild(liHeading);
		msg.appendChild(ul);
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
		var parse2 = $($.parseXML(xmlContent3));
		try {
			if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}
			parse2.find("mtitle").each(function () {
				if ($(this).attr("name") == title) {
					//msg.style.fontWeight = "bold";
					//msg.innerText = title;
					//msg.setAttribute("class", "showArrow");
					//msg.setAttribute("href", "#titleDefDiv");
					aHeading.setAttribute("class", "showArrow");					
					aHeading.setAttribute("href", "#titleDefDiv");
					
					var ulDef = document.createElement("ul");
					var liDef = document.createElement("li");
					var aDef = document.createElement("a");
					aDef.innerText = $(this).attr("definition");
					liDef.appendChild(aDef);
					ulDef.appendChild(liDef);
					div.appendChild(ulDef);
                    return false;    
				}
			});
		}
		catch (e) {
			div.appendChild(document.createTextNode("There was an error processing at this point."));
		}
		return aHeading;
	}
	
   /* event handlers */

	function _onServiceClick(e) {
		var title = this.getAttribute("title");            
		var serviceId = this.getAttribute("service");
		var codeId = this.getAttribute("id");
		parseCodes(title, serviceId, codeId);
		
		animatedcollapse.init();
		return false; // disableDefault
	}
	function _onExamClick(e) {
		var examDesc = this.getAttribute("exam");
		parseExam(examDesc);
		return false; // disableDefault
	}
	function _onCodeRvuClick(e) {
		var codeId = this.getAttribute("code");
		parseCodeRvu(codeId);            
		return false; // disableDefault
	}
	function _onHistoryClick(e) {
		var hx = this.getAttribute("hx");
		parseHistory(hx);
		return false; // disableDefault
	}
	function _calcFacilityFee() {
		var facilityFee = 0;
		// 
		//Facility Pricing Amount =
		//[(Work RVU * Work GPCI) +
		//(Facility PE RVU * PE GPCI) +
		//(MP RVU * MP GPCI)] * Conversion Factor
		//
		facilityFee = (((globalWorkRVU * globalWork2011gpci1) + 
			(globalTransitionedFacilityPERVU * globalPE2011gpci2) +
			(globalMPRVU * globalMP2011gpci)) * globalConvfactor);
		return facilityFee;  
	}
	function _calcNonFacilityFee() {
		var nonFacilityFee = 0;
		// 
		// Non-Facility Pricing Amount =
		// [(Work RVU *  Work GPCI) + 
		// (Transitioned Non-Facility PE RVU * PE GPCI) + 
		// (MP RVU * MP GPCI)] * Conversion Factor (CF)
		//
		nonFacilityFee = (((globalWorkRVU * globalWork2011gpci1) +
			(globalTransitionedNonFacPERVU * globalPE2011gpci2) +
			(globalMPRVU * globalMP2011gpci)) * globalConvfactor);
		return nonFacilityFee; 
	}
    var gCalcFacFee = null;
	function calcFacilityFee(codeId) {
		var localFacilityFee = 0;
		var xml = document.getElementById('rvu');
		if (xml.documentElement == null)
			xml.documentElement = xml.firstChild;
		var xmlContent3 = "<?xml version='1.0'?>" + xml.innerHTML;
        if (gCalcFacFee == null) {
		    gCalcFacFee = $($.parseXML(xmlContent3));
        }
		try {
			/*if (typeof parse2 === 'object') {
				for (var prop in parse2) {
					//testOutputText += "	property: " + prop + " value: [" + parse2[prop] + "]\n";
				}
			}*/
			gCalcFacFee.find("code").each(function () {                   
				var local1 = parseInt($(this).find("hcpcs").text(), 10);
				var local2 = parseInt(codeId, 10);
				if (local2 == local1) {
					globalWorkRVU = parseFloat($(this).find("workrvu").text());
					globalMPRVU = parseFloat($(this).find("mprvu").text());
					globalConvfactor = parseFloat($(this).find("convfactor").text());
					globalTransitionedFacilityPERVU = parseFloat($(this).find("transitionedfacilitypervu").text());
					globalTransitionedNonFacPERVU = parseFloat($(this).find("transitionednon-facpervu").text());

					localFacilityFee = _calcFacilityFee();
                    return false;    				
				}
			});
		}
		catch (e) {
			localFacilityFee = -1;
		}
		return localFacilityFee;
	}

	/* 101 codes */
	/* 164 gcpis */	

	/* UI handlers */
	function onStateChange(e) {
		globalState = e.options[e.selectedIndex].getAttribute("stateId");
		globalCounty = e.options[e.selectedIndex].getAttribute("countyId");
		saveLocation();
		parseGCPI(globalState, globalCounty);
	}
  
	function onVisitsClick(e) {
		populateAllVisits();
		updateUserStats();
	}

	function onRiskTable(e) {		
		populateMdmRiskTable(1, "problem");		
		populateMdmRiskTable(2, "diagnosis");		
		populateMdmRiskTable(3, "management");

		animatedcollapse.addDiv('riskDiv1', 'optional_attribute_string');
		animatedcollapse.addDiv('riskDiv2', 'optional_attribute_string');
		animatedcollapse.addDiv('riskDiv3', 'optional_attribute_string');
		animatedcollapse.init();
	}

	function populateUserStats() {
		for (var i in globalArrayRVU) {
			var statCode = document.getElementById(i.split('_')[1]);
			var sp = statCode.split('_');
			var serviceId = sp[2];
			var header = document.getElementById(serviceId + "visitsDiv" + serviceId);
			if (globalArrayRVU[i] > 0) {
				statCode.value = globalArrayRVU[i];
				header.style.color = "red";
			}
			else {
				header.style.color = "#6495ed";
			}
		}
	}

	function _onVisitInputChange(e) {
		globalArrayRVU[e.srcElement.id] = parseInt(e.srcElement.value, 10);
		updateUserStats();
	}

	function updateUserStats() {
		globalTotalVisits = 0;
		globalTotalRVU = 0;        
		globalFacilityFee = 0;

		for (var i in globalArrayRVU) {
			globalTotalVisits += globalArrayRVU[i];
			var c = i.split('_')[1];            
			var serviceId = i.split('_')[2];            
			var header = document.getElementById(serviceId + "visitsDiv" + serviceId);
			if (globalArrayRVU[i] > 0) {
				globalTotalRVU += globalArrayRVU[i] * parseFloat(calcWorkRvu(c));
				globalFacilityFee += globalArrayRVU[i] * calcFacilityFee(c);
				header.style.color = "red";
			}
			else {
				header.style.color = "#6495ed";
			}
		}

		var visits = document.getElementById("totalVisits");
		visits.value = globalTotalVisits;
		var rvus = document.getElementById("totalRVUs");
		rvus.value = globalTotalRVU.toFixed(2);
		var facfees = document.getElementById("totalFacFees");
		facfees.value = globalFacilityFee.toFixed(2);
		saveStats();
	}
	// process the confirmation dialog result    
	function onConfirm(button) {	   
	    if (button == 'Yes') {
	        globalArrayRVU = new Array();
	        updateUserStats();
	        $("#visits input").each(function () {
	            if ($(this)[0].value != "Clear") {
	                $(this)[0].value = 0;
	            }
	        });
	        populateAllVisits();
	    }
	}
	// Show a custom confirmation dialog    
    //    
    function showConfirm() {
        navigator.notification.confirm('Are you want to clear your stats?',  
        // message            
        onConfirm,              
        // callback to invoke with index of button pressed            
        'Confirm',            
        // title            
        'Yes,No'
        // buttonLabels        
        );    
    }
	function onClearStats(e) {
	    var ans = false;
	    showConfirm();		
	}

	function saveStats() {
		var strArray = object2String(globalArrayRVU);
		setCookie("stats", strArray, 365);
	}

	function loadStats() {
		var data;
		data = getCookie("stats");
		if (data && data.length > 1) {
			var arrayRVU = string2Object(data);
			if (arrayRVU) {
				globalArrayRVU = arrayRVU; 
			}
		}
	}

	function saveLocation() {
		setCookie("state", globalState, 365);
		setCookie("county", globalCounty, 365);
	}

	function loadLocation() {
		var data;
		data = getCookie("state");
		if (data) {
			globalState = data;
		}
		data = getCookie("county");
		if (data) {
			globalCounty = data;
		}
	}

	function getCookie(c_name) {
		if (localStorage) {
			var item;
			item = localStorage.getItem(c_name);
			return item;
		}
		else {
			var i, x, y, ARRcookies = document.cookie.split(";");
			for (i = 0; i < ARRcookies.length; i++) {
				x = ARRcookies[i].substr(0, ARRcookies[i].indexOf("="));
				y = ARRcookies[i].substr(ARRcookies[i].indexOf("=") + 1);
				x = x.replace(/^\s+|\s+$/g, "");
				if (x == c_name) {
					return unescape(y);
				}
			}
		}
	}

	function setCookie(c_name, value, exdays) {
		if (localStorage) {
			localStorage.setItem(c_name, value);
		}
		else {
			var exdate = new Date();
			exdate.setDate(exdate.getDate() + exdays);
			var c_value = escape(value) + ((exdays == null) ? "" : "; expires=" + exdate.toUTCString());
			document.cookie = c_name + "=" + c_value;			
		}
	}
 
	function _onVisitServiceClick(e) {
		var id = e.srcElement.getAttribute("serviceId");
		if (e.srcElement.getAttribute("class") == "subheadingCollapse")
			e.srcElement.setAttribute("class", "subheadingExpand");
		else
			e.srcElement.setAttribute("class", "subheadingCollapse");
		var visitsId = "visitsDiv" + id;
		animatedcollapse.toggle(visitsId);
	}

	function _onMdmRiskClick(e) {
		var id = e.srcElement.getAttribute("riskId");
		if (e.srcElement.getAttribute("class") == "subheadingCollapse")
			e.srcElement.setAttribute("class", "subheadingExpand");
		else
			e.srcElement.setAttribute("class", "subheadingCollapse");
		var riskId = "riskDiv" + id;
		animatedcollapse.toggle(riskId);
	}

	function _onExpandCode(e) {
		var id = e.srcElement.getAttribute("hemId");
		if (e.srcElement.getAttribute("class") == "subheadingCollapse")
			e.srcElement.setAttribute("class", "subheadingExpand");
		else
			e.srcElement.setAttribute("class", "subheadingCollapse");
		var hemDiv = "hemDiv" + id;
		animatedcollapse.toggle(hemDiv);
	}

	function _onExpandServiceDiv (e) {
		var id = e.srcElement.getAttribute("serviceId");
		if (e.srcElement.getAttribute("class") == "subheadingCollapse")
			e.srcElement.setAttribute("class", "subheadingExpand");
		else
			e.srcElement.setAttribute("class", "subheadingCollapse");
		var serviceDiv = "serviceDiv" + id;
		animatedcollapse.toggle(serviceDiv);
	}

	function _onExpandTimeCodes(e) {
		var id = e.srcElement.getAttribute("serviceId");
		if (e.srcElement.getAttribute("class") == "subheadingCollapse")
			e.srcElement.setAttribute("class", "subheadingExpand");
		else
			e.srcElement.setAttribute("class", "subheadingCollapse");
		var serviceDiv = "serviceDiv" + id;
		animatedcollapse.toggle(serviceDiv);
	}
	